----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:20:11 12/08/2013 
-- Design Name: 
-- Module Name:    GPMC_SLAVE - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;
library grlib, techmap;
use grlib.stdlib.all;
use techmap.gencomp.all;
use techmap.allclkgen.all;
library lpp;
use lpp.general_purpose.all;

entity GPMC_ASYNC_SLAVE is
  generic (
    memtech       : integer := 0;
    padtech       : integer := 0
  );
    Port ( 
	     clk           : in  STD_LOGIC;
        reset         : in  STD_LOGIC;
        GPMC_AD       : inout std_logic_vector(15 downto 0);
        GPMC_A        : in  std_logic_vector(19 downto 0);
        GPMC_CLK_MUX0 : in  std_ulogic;
        GPMC_WEN      : in  std_ulogic;   
        GPMC_OEN_REN  : in  std_ulogic;  
        GPMC_ADVN_ALE : in  std_ulogic;   
        GPMC_CSN      : in  std_ulogic_vector(2 downto 0);
        GPMC_BE0N_CLE : in  std_ulogic; 
        GPMC_BE1N     : in  std_ulogic;
        GPMC_WAIT0    : out std_ulogic;
        GPMC_WPN      : in  std_ulogic
		  );
end GPMC_ASYNC_SLAVE;

architecture Behavioral of GPMC_ASYNC_SLAVE is
constant VectInit : std_logic_vector(15 downto 0):=(others => '0');

signal data_out :std_logic_vector(15 downto 0);
signal data_in  :std_logic_vector(15 downto 0);

type    RAMarrayT   is array (0 to 255) of std_logic_vector(15 downto 0);
signal  RAMarray           :   RAMarrayT:=(others => VectInit);
signal  ramindex         : integer range 0 to 255;

begin

data_pad : iopadv generic map (tech=> padtech,width => 16)
port map (
   pad => GPMC_AD(15 downto 0),
   o   => data_in(15 downto 0),
   en  => GPMC_OEN_REN,
   i   => data_out(15 downto 0)
);

GPMC_WAIT0  <=  '1';

data_out <= RAMarray(ramindex);

process(reset,GPMC_CLK_MUX0)
begin
if reset = '0' then
	--data_out	<= (others => '0');
	ramindex <= 0;
elsif GPMC_CLK_MUX0'event and GPMC_CLK_MUX0 = '1' then
	if GPMC_ADVN_ALE = '0' then
		ramindex <= to_integer(unsigned(GPMC_A(19 downto 1)));
	end if;

	if GPMC_WEN = '0' then 
		RAMarray(ramindex) <= data_in; 
	end if;
end if;
end process;

end Behavioral;














